declare namespace math="java:java.lang.Math";
declare namespace functx = "http://www.functx.com";
declare namespace timHelper ="java:com.torokina.tim.plugin.xquery.TimXQueryHelper";

declare function functx:substring-after-last 
  ( $arg as xs:string? ,
    $delim as xs:string )  as xs:string {
   replace ($arg,concat('^.*',functx:escape-for-regex($delim)),'')
} ;
declare function functx:escape-for-regex 
  ( $arg as xs:string? )  as xs:string {
   replace($arg,
           '(\.|\[|\]|\\|\||\-|\^|\$|\?|\*|\+|\{|\}|\(|\))','\\$1')
} ;

declare variable $InputFile as xs:string external;
declare variable $DeltaTime as xs:integer external;
let $doc := doc(iri-to-uri($InputFile))

let $DATAFileds := 'BitsIn:'
             
let $DATAGroup := 
        for $obj in $doc/root/group[*]        
                let $Device := $obj/Device/text()          
                let $TimeStamp := $obj/Timestamp/text()
                let $Group := $obj/Group/text()
                let $Branch := 'Aggregates2'
                let $Internal := 
                    for $i in $obj/*
			         let $localname := fn:local-name($i)
			         let $localValue := $i/text()
			         let $replacename := concat('DATA-',$localname)
		             return 
	                if (contains($DATAFileds,fn:concat($localname,':'))) then ((element {$replacename} {$localValue}) )
		                else ()
		  return
		  element group{
			element TIM-Device {$Device},
			element TIM-deviceIP {''},
			element TIM-Branch {$Branch},
			element TIM-BranchDescr {$Group},		
			element TIM-utc {$TimeStamp},
            element TIM-Delta {$DeltaTime},
            $Internal     
         }
	  
return
<root deviceType="CAAggExample2">
{
	   $DATAGroup
}
</root>







